package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLSet_userImport) ENABLED START ***/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLSet extends JNIObject implements IISLSingleSpaceSetMethods, IISLProjectionMethods {
	
	/* @generated */
	protected ISLSet(long ptr) {
		/*** PROTECTED REGION ID(ISLSet_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLSet build(long ptr) {
		return new ISLSet(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLSet_userCode) ENABLED START ***/
	public String toString(ISL_FORMAT format) {
		return ISLPrettyPrinter.asString(this, format);
	}
	
	public ISLMap toIdentityMap() {
		return buildIdentityMap();
	}

	public ISLMap buildIdentityMap() {
		ISLMap map = ISLMap.buildFromDomainAndRange(this.copy(), this.copy());
		for (int i = 0; i < this.getNbIndices(); i++) {
			map = map.sliceEquate(ISLDimType.isl_dim_in, i, ISLDimType.isl_dim_out, i);
		}
		return map;
	}
	
	public ISLSet eliminateDims(int first, int n) {
		return eliminate(ISLDimType.isl_dim_set, first, n);
	}

	public ISLSet extend(int nparam, int dim) {
		ISLSet res = this.addDims(ISLDimType.isl_dim_param, nparam);
		res = res.addDims(ISLDimType.isl_dim_set, dim);
		return res;
	}
	
	/**
	 * computes this.detectEqualities().coalesce().removeRedundancies() and
	 * then tries, in order to reduce the number of basic sets : 
	 * this.copy().simpleHull().toSet().subtract(this.copy().complement());
	 */
	public ISLSet simplify() {
		ISLSet s = this.detectEqualities().coalesce().removeRedundancies();
		ISLSet simplify = s.copy().simpleHull().toSet()
				.subtract(s.copy().complement());
		if (simplify.getNbBasicSets() < s.getNbBasicSets())
			s = simplify;
		s = s.detectEqualities().coalesce().removeRedundancies();
		return s;
	}

	public ISLSet pad(int dim, int size) {
		ISLSet res = this.copy();

		ISLBasicMap shift = ISLBasicMap.buildUniverse(ISLSpace
				.idMapDimFromSetDim(res.getSpace().copy()));
		long n = res.getSpace().dim(ISLDimType.isl_dim_set);
		for (int i = 0; i < n; i++) {
			if (i != dim) {
				ISLConstraint c = ISLConstraint.buildEquality(shift.getSpace().copy().toLocalSpace());
				c = c.setCoefficient(ISLDimType.isl_dim_in, i, 1);
				c = c.setCoefficient(ISLDimType.isl_dim_out, i, -1);
				shift = shift.addConstraint(c);
			} else {
				ISLConstraint c1 = ISLConstraint
						.buildInequality(shift.getSpace().copy().toLocalSpace());
				c1 = c1.setCoefficient(ISLDimType.isl_dim_in, i, -1);
				c1 = c1.setCoefficient(ISLDimType.isl_dim_out, i, 1);

				ISLConstraint c2 = ISLConstraint
						.buildInequality(shift.getSpace().copy().toLocalSpace());
				c2 = c2.setCoefficient(ISLDimType.isl_dim_in, i, 1);
				c2 = c2.setCoefficient(ISLDimType.isl_dim_out, i, -1);
				c2 = c2.setConstant(size);

				shift = shift.addConstraint(c1);
				shift = shift.addConstraint(c2);
			}
		}
		ISLMap shiftMap = shift.toMap();
		res = res.apply(shiftMap);
		return res.coalesce();
	}

	public ISLSet expandTo(ISLSet mergedDomains) {
		return JNIISLTools.expandTo(this, mergedDomains);
	}

	public List<ISLBasicSet> getBasicSets() {
		List<ISLBasicSet> res = new ArrayList<ISLBasicSet>();
		for (int i = 0; i < getNbBasicSets(); i++) {
			res.add(getBasicSetAt(i));
		}
		return res;
	}

	public static String asList(List<? extends Object> objs, String sep) {
		String res = "";
		boolean first = true;
		for (Object obj : objs) {
			if (!first) {
				res += sep;
			}
			res += obj.toString();
			first = false;
		}
		return res;

	}

	public ISLSet convertTo(ISLSpace target) {
		ISLSpace space = this.getSpace();
		if (target.dim(ISLDimType.isl_dim_param) != space
				.dim(ISLDimType.isl_dim_param)) {
			throw new UnsupportedOperationException(
					"Parameter mismatch : cannnot convert " + space + " to "
							+ target);
		} else {
			String mapStr = "" + this.getParamNames() + "-> { "
					+ getIndexNames() + " ->  "
					+ target.getDimNames(ISLDimType.isl_dim_set) + "  :";
			List<String> nameList = space
					.getDimNames(ISLDimType.isl_dim_set);
			List<String> assgnList = new ArrayList<String>();
			List<String> targetNames = target
					.getDimNames(ISLDimType.isl_dim_set);
			int insize = nameList.size();
			for (int i = 0; i < insize; i++) {
				assgnList.add(targetNames.get(i) + "=" + nameList.get(i));
			}
			mapStr += asList(assgnList, " & ") + " }";
			ISLMap islMap = ISLFactory.islMap(mapStr);
			return this.copy().apply(islMap);
		}
	}

	public List<ISLPoint> getPoints() {
		int n = this.getNbPoints();
		List<ISLPoint> res = new ArrayList<ISLPoint>(n);
		for (int i = 0; i < n; i++) {
			res.add(this.getPointAt(i));
		}
		return res;
	}

	public ISLMap lexFirstMap(int nbLoops) {
		int n = (int) this.getNbIndices() - nbLoops;
		ISLMap m = ISLMap.buildFromDomainAndRange(
				ISLSet.buildUniverse(this.getSpace().copy()), this.copy());
		ISLBasicMap bm = ISLBasicMap.buildUniverse(m.getSpace());
		for (int i = 0; i < n; i++) {
			ISLConstraint c = ISLConstraint.buildEquality(m.getSpace().toLocalSpace());
			c = c.setCoefficient(ISLDimType.isl_dim_in, i, 1);
			c = c.setCoefficient(ISLDimType.isl_dim_out, i, -1);
			bm = bm.addConstraint(c);
		}
		ISLMap ma = bm.toMap();
		m = m.intersect(ma).lexMin();
		//m = m.projectOut(JNIISLDimType.isl_dim_out, 0, n);
		return m;
	}


	/**
	 * keeps only one given dimension (pos) of the given dimension type
	 * 
	 * @param type
	 * @param pos
	 * @return
	 */
	public ISLSet projectIn(ISLDimType type, int pos) {
		int nbdims = (int) this.getSpace().dim(type);
		if (pos < 0 || pos >= nbdims)
			throw new IllegalArgumentException();
		ISLSet res = this;
		if (pos + 1 <= nbdims - 1)
			res = res.projectOut(type, pos + 1, nbdims - pos - 1);
		if (pos - 1 >= 0)
			res = res.projectOut(type, 0, pos);
		
		return res;
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_set_read_from_str 
	 * 
	 * @generated
	**/
	 public static ISLSet buildFromString(ISLContext ctx, String str) { 
		/*** PROTECTED REGION ID(static_isl_set_read_from_str) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSet.build(ISLNative.isl_set_read_from_str(getNativePtr(ctx), str));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_empty 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLSet buildEmpty(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_set_empty) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLSet.build(ISLNative.isl_set_empty(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_universe 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLSet buildUniverse(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_set_universe) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLSet.build(ISLNative.isl_set_universe(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_nat_universe 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLSet buildNonNegUniverse(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_set_nat_universe) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLSet.build(ISLNative.isl_set_nat_universe(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_eq_set 
	 * 
	@take aff1 aff2
	 * @generated
	**/
	 public static ISLSet buildEQSet(ISLAff aff1, ISLAff aff2) { 
		/*** PROTECTED REGION ID(static_isl_aff_eq_set) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(aff1, aff2);
			try {
				res = ISLSet.build(ISLNative.isl_aff_eq_set(getNativePtr(aff1), getNativePtr(aff2)));
			} finally {
				taken(aff1);
				taken(aff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_ne_set 
	 * 
	@take aff1 aff2
	 * @generated
	**/
	 public static ISLSet buildNESet(ISLAff aff1, ISLAff aff2) { 
		/*** PROTECTED REGION ID(static_isl_aff_ne_set) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(aff1, aff2);
			try {
				res = ISLSet.build(ISLNative.isl_aff_ne_set(getNativePtr(aff1), getNativePtr(aff2)));
			} finally {
				taken(aff1);
				taken(aff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_le_set 
	 * 
	@take aff1 aff2
	 * @generated
	**/
	 public static ISLSet buildLESet(ISLAff aff1, ISLAff aff2) { 
		/*** PROTECTED REGION ID(static_isl_aff_le_set) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(aff1, aff2);
			try {
				res = ISLSet.build(ISLNative.isl_aff_le_set(getNativePtr(aff1), getNativePtr(aff2)));
			} finally {
				taken(aff1);
				taken(aff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_lt_set 
	 * 
	@take aff1 aff2
	 * @generated
	**/
	 public static ISLSet buildLTSet(ISLAff aff1, ISLAff aff2) { 
		/*** PROTECTED REGION ID(static_isl_aff_lt_set) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(aff1, aff2);
			try {
				res = ISLSet.build(ISLNative.isl_aff_lt_set(getNativePtr(aff1), getNativePtr(aff2)));
			} finally {
				taken(aff1);
				taken(aff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_ge_set 
	 * 
	@take aff1 aff2
	 * @generated
	**/
	 public static ISLSet buildGESet(ISLAff aff1, ISLAff aff2) { 
		/*** PROTECTED REGION ID(static_isl_aff_ge_set) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(aff1, aff2);
			try {
				res = ISLSet.build(ISLNative.isl_aff_ge_set(getNativePtr(aff1), getNativePtr(aff2)));
			} finally {
				taken(aff1);
				taken(aff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_gt_set 
	 * 
	@take aff1 aff2
	 * @generated
	**/
	 public static ISLSet buildGTSet(ISLAff aff1, ISLAff aff2) { 
		/*** PROTECTED REGION ID(static_isl_aff_gt_set) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(aff1, aff2);
			try {
				res = ISLSet.build(ISLNative.isl_aff_gt_set(getNativePtr(aff1), getNativePtr(aff2)));
			} finally {
				taken(aff1);
				taken(aff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLSet set, int format) { 
		/*** PROTECTED REGION ID(static_isl_set_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_to_string(getNativePtr(set), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_union_set_from_set 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSet toUnionSet() {
		/*** PROTECTED REGION ID(isl_union_set_from_set) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_from_set(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_from_params 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet toSetFromParamSet() {
		/*** PROTECTED REGION ID(isl_set_from_params) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_from_params(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_from_set 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPWMultiAff toPWMultiAff() {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_from_set) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_from_set(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_list_from_set 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSetList toList() {
		/*** PROTECTED REGION ID(isl_set_list_from_set) DISABLED START ***/
		ISLSetList res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSetList.build(ISLNative.isl_set_list_from_set(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_set_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_set_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_get_space 
	 * 
	 * @generated
	**/
	public ISLSpace getSpace() {
		/*** PROTECTED REGION ID(isl_set_get_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_set_get_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_copy 
	 * 
	 * @generated
	**/
	public ISLSet copy() {
		/*** PROTECTED REGION ID(isl_set_copy) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSet.build(ISLNative.isl_set_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_set_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_set_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_add_constraint 
	 * 
	 * @take this constraint
	 * @generated
	**/
	public ISLSet addConstraint(ISLConstraint constraint) {
		/*** PROTECTED REGION ID(isl_set_add_constraint) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this, constraint);
			try {
				res = ISLSet.build(ISLNative.isl_set_add_constraint(getNativePtr(this), getNativePtr(constraint)));
			} finally {
				taken(this);
				taken(constraint);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_n_basic_set 
	 * 
	 * @generated
	**/
	public int getNbBasicSets() {
		/*** PROTECTED REGION ID(isl_set_n_basic_set) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_n_basic_set(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_make_disjoint 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet makeDisjoint() {
		/*** PROTECTED REGION ID(isl_set_make_disjoint) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_make_disjoint(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_compute_divs 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet computeDivs() {
		/*** PROTECTED REGION ID(isl_set_compute_divs) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_compute_divs(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_remove_divs 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet removeDivs() {
		/*** PROTECTED REGION ID(isl_set_remove_divs) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_remove_divs(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_remove_unknown_divs 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet removeUnknownDivs() {
		/*** PROTECTED REGION ID(isl_set_remove_unknown_divs) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_remove_unknown_divs(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_remove_divs_involving_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet removeDivsInvolvingDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_set_remove_divs_involving_dims) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_remove_divs_involving_dims(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_dim 
	 * 
	 * @generated
	**/
	public int dim(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_set_dim) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_dim(getNativePtr(this), type.getValue());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_get_tuple_name 
	 * 
	 * @generated
	**/
	public String getTupleName() {
		/*** PROTECTED REGION ID(isl_set_get_tuple_name) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_get_tuple_name(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_set_tuple_name 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet setTupleName(String s) {
		/*** PROTECTED REGION ID(isl_set_set_tuple_name) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_set_tuple_name(getNativePtr(this), s));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_get_dim_name 
	 * 
	 * @generated
	**/
	public String getDimName(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_set_get_dim_name) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_get_dim_name(getNativePtr(this), type.getValue(), pos);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_set_dim_name 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet setDimName(ISLDimType type, int pos, String s) {
		/*** PROTECTED REGION ID(isl_set_set_dim_name) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_set_dim_name(getNativePtr(this), type.getValue(), pos, s));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_has_tuple_name 
	 * 
	 * @generated
	**/
	public boolean hasTupleName() {
		/*** PROTECTED REGION ID(isl_set_has_tuple_name) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_has_tuple_name(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_has_dim_name 
	 * 
	 * @generated
	**/
	public boolean hasDimName(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_set_has_dim_name) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_has_dim_name(getNativePtr(this), type.getValue(), pos) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_find_dim_by_name 
	 * 
	 * @generated
	**/
	public int findDimByName(ISLDimType type, String name) {
		/*** PROTECTED REGION ID(isl_set_find_dim_by_name) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_find_dim_by_name(getNativePtr(this), type.getValue(), name);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_involves_dims 
	 * 
	 * @generated
	**/
	public boolean involvesDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_set_involves_dims) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_involves_dims(getNativePtr(this), type.getValue(), first, n) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_get_tuple_id 
	 * 
	 * @generated
	**/
	public ISLIdentifier getTupleID() {
		/*** PROTECTED REGION ID(isl_set_get_tuple_id) DISABLED START ***/
		ISLIdentifier res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLIdentifier.build(ISLNative.isl_set_get_tuple_id(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_get_dim_id 
	 * 
	 * @generated
	**/
	public ISLIdentifier getDimID(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_set_get_dim_id) DISABLED START ***/
		ISLIdentifier res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLIdentifier.build(ISLNative.isl_set_get_dim_id(getNativePtr(this), type.getValue(), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_has_tuple_id 
	 * 
	 * @generated
	**/
	public boolean hasTupleID() {
		/*** PROTECTED REGION ID(isl_set_has_tuple_id) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_has_tuple_id(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_has_dim_id 
	 * 
	 * @generated
	**/
	public boolean hasDimID(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_set_has_dim_id) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_has_dim_id(getNativePtr(this), type.getValue(), pos) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_set_tuple_id 
	 * 
	 * @take this id
	 * @generated
	**/
	public ISLSet setTupleID(ISLIdentifier id) {
		/*** PROTECTED REGION ID(isl_set_set_tuple_id) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this, id);
			try {
				res = ISLSet.build(ISLNative.isl_set_set_tuple_id(getNativePtr(this), getNativePtr(id)));
			} finally {
				taken(this);
				taken(id);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_set_dim_id 
	 * 
	 * @take this id
	 * @generated
	**/
	public ISLSet setDimID(ISLDimType type, int pos, ISLIdentifier id) {
		/*** PROTECTED REGION ID(isl_set_set_dim_id) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this, id);
			try {
				res = ISLSet.build(ISLNative.isl_set_set_dim_id(getNativePtr(this), type.getValue(), pos, getNativePtr(id)));
			} finally {
				taken(this);
				taken(id);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_find_dim_by_id 
	 * 
	 * @generated
	**/
	public int findDimByID(ISLDimType type, ISLIdentifier id) {
		/*** PROTECTED REGION ID(isl_set_find_dim_by_id) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_find_dim_by_id(getNativePtr(this), type.getValue(), getNativePtr(id));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_reset_tuple_id 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet resetTupleID() {
		/*** PROTECTED REGION ID(isl_set_reset_tuple_id) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_reset_tuple_id(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_dim_has_upper_bound 
	 * 
	 * @generated
	**/
	public boolean hasUpperBound(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_set_dim_has_upper_bound) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_dim_has_upper_bound(getNativePtr(this), type.getValue(), pos) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_dim_has_lower_bound 
	 * 
	 * @generated
	**/
	public boolean hasLowerBound(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_set_dim_has_lower_bound) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_dim_has_lower_bound(getNativePtr(this), type.getValue(), pos) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_dim_has_any_upper_bound 
	 * 
	 * @generated
	**/
	public boolean hasAnyUpperBound(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_set_dim_has_any_upper_bound) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_dim_has_any_upper_bound(getNativePtr(this), type.getValue(), pos) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_dim_has_any_lower_bound 
	 * 
	 * @generated
	**/
	public boolean hasAnyLowerBound(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_set_dim_has_any_lower_bound) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_dim_has_any_lower_bound(getNativePtr(this), type.getValue(), pos) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_plain_is_empty 
	 * 
	 * @generated
	**/
	public boolean plainIsEmpty() {
		/*** PROTECTED REGION ID(isl_set_plain_is_empty) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_plain_is_empty(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_is_empty 
	 * 
	 * @generated
	**/
	public boolean isEmpty() {
		/*** PROTECTED REGION ID(isl_set_is_empty) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_is_empty(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_plain_is_universe 
	 * 
	 * @generated
	**/
	public boolean plainIsUniverse() {
		/*** PROTECTED REGION ID(isl_set_plain_is_universe) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_plain_is_universe(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_is_singleton 
	 * 
	 * @generated
	**/
	public boolean isSingleton() {
		/*** PROTECTED REGION ID(isl_set_is_singleton) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_is_singleton(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_is_params 
	 * 
	 * @generated
	**/
	public boolean isParamSet() {
		/*** PROTECTED REGION ID(isl_set_is_params) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_is_params(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_is_wrapping 
	 * 
	 * @generated
	**/
	public boolean isWrapping() {
		/*** PROTECTED REGION ID(isl_set_is_wrapping) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_is_wrapping(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_sample_point 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPoint samplePoint() {
		/*** PROTECTED REGION ID(isl_set_sample_point) DISABLED START ***/
		ISLPoint res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPoint.build(ISLNative.isl_set_sample_point(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_plain_is_equal 
	 * 
	 * @generated
	**/
	public boolean isPlainEqual(ISLSet set2) {
		/*** PROTECTED REGION ID(isl_set_plain_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_plain_is_equal(getNativePtr(this), getNativePtr(set2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_is_equal 
	 * 
	 * @generated
	**/
	public boolean isEqual(ISLSet set2) {
		/*** PROTECTED REGION ID(isl_set_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_is_equal(getNativePtr(this), getNativePtr(set2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_plain_is_disjoint 
	 * 
	 * @generated
	**/
	public boolean isPlainDisjoint(ISLSet set2) {
		/*** PROTECTED REGION ID(isl_set_plain_is_disjoint) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_plain_is_disjoint(getNativePtr(this), getNativePtr(set2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_is_disjoint 
	 * 
	 * @generated
	**/
	public boolean isDisjoint(ISLSet set2) {
		/*** PROTECTED REGION ID(isl_set_is_disjoint) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_is_disjoint(getNativePtr(this), getNativePtr(set2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_is_subset 
	 * 
	 * @generated
	**/
	public boolean isSubset(ISLSet set2) {
		/*** PROTECTED REGION ID(isl_set_is_subset) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_is_subset(getNativePtr(this), getNativePtr(set2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_is_strict_subset 
	 * 
	 * @generated
	**/
	public boolean isStrictSubset(ISLSet set2) {
		/*** PROTECTED REGION ID(isl_set_is_strict_subset) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_is_strict_subset(getNativePtr(this), getNativePtr(set2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_params 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet params() {
		/*** PROTECTED REGION ID(isl_set_params) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_params(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_complement 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet complement() {
		/*** PROTECTED REGION ID(isl_set_complement) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_complement(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_project_out 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet projectOut(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_set_project_out) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_project_out(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_eliminate 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet eliminate(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_set_eliminate) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_eliminate(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_fix_si 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet sliceFixed(ISLDimType type, int pos, int value) {
		/*** PROTECTED REGION ID(isl_set_fix_si) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_fix_si(getNativePtr(this), type.getValue(), pos, value));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_fix_val 
	 * 
	 * @take this v
	 * @generated
	**/
	public ISLSet sliceFixed(ISLDimType type, int pos, ISLVal v) {
		/*** PROTECTED REGION ID(isl_set_fix_val) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this, v);
			try {
				res = ISLSet.build(ISLNative.isl_set_fix_val(getNativePtr(this), type.getValue(), pos, getNativePtr(v)));
			} finally {
				taken(this);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_lower_bound_si 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet sliceLB(ISLDimType type, int pos, int value) {
		/*** PROTECTED REGION ID(isl_set_lower_bound_si) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_lower_bound_si(getNativePtr(this), type.getValue(), pos, value));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_lower_bound_val 
	 * 
	 * @take this value
	 * @generated
	**/
	public ISLSet sliceLB(ISLDimType type, int pos, ISLVal value) {
		/*** PROTECTED REGION ID(isl_set_lower_bound_val) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this, value);
			try {
				res = ISLSet.build(ISLNative.isl_set_lower_bound_val(getNativePtr(this), type.getValue(), pos, getNativePtr(value)));
			} finally {
				taken(this);
				taken(value);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_upper_bound_si 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet sliceUB(ISLDimType type, int pos, int value) {
		/*** PROTECTED REGION ID(isl_set_upper_bound_si) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_upper_bound_si(getNativePtr(this), type.getValue(), pos, value));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_upper_bound_val 
	 * 
	 * @take this value
	 * @generated
	**/
	public ISLSet sliceUB(ISLDimType type, int pos, ISLVal value) {
		/*** PROTECTED REGION ID(isl_set_upper_bound_val) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this, value);
			try {
				res = ISLSet.build(ISLNative.isl_set_upper_bound_val(getNativePtr(this), type.getValue(), pos, getNativePtr(value)));
			} finally {
				taken(this);
				taken(value);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_equate 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet sliceEquate(ISLDimType type1, int pos1, ISLDimType type2, int pos2) {
		/*** PROTECTED REGION ID(isl_set_equate) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_equate(getNativePtr(this), type1.getValue(), pos1, type2.getValue(), pos2));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_identity 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap identity() {
		/*** PROTECTED REGION ID(isl_set_identity) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_set_identity(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_coalesce 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet coalesce() {
		/*** PROTECTED REGION ID(isl_set_coalesce) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_coalesce(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_detect_equalities 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet detectEqualities() {
		/*** PROTECTED REGION ID(isl_set_detect_equalities) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_detect_equalities(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_remove_redundancies 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet removeRedundancies() {
		/*** PROTECTED REGION ID(isl_set_remove_redundancies) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_remove_redundancies(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_convex_hull 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet convexHull() {
		/*** PROTECTED REGION ID(isl_set_convex_hull) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_set_convex_hull(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_affine_hull 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet affineHull() {
		/*** PROTECTED REGION ID(isl_set_affine_hull) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_set_affine_hull(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_polyhedral_hull 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet polyhedralHull() {
		/*** PROTECTED REGION ID(isl_set_polyhedral_hull) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_set_polyhedral_hull(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_simple_hull 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet simpleHull() {
		/*** PROTECTED REGION ID(isl_set_simple_hull) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_set_simple_hull(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_unshifted_simple_hull 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet unshiftedSimpleHull() {
		/*** PROTECTED REGION ID(isl_set_unshifted_simple_hull) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_set_unshifted_simple_hull(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_drop_constraints_involving_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet dropConstraintsInvolvingDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_set_drop_constraints_involving_dims) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_drop_constraints_involving_dims(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_sample 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet sample() {
		/*** PROTECTED REGION ID(isl_set_sample) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_set_sample(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_unwrap 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap unwrap() {
		/*** PROTECTED REGION ID(isl_set_unwrap) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_set_unwrap(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_flatten 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet flatten() {
		/*** PROTECTED REGION ID(isl_set_flatten) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_flatten(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_flatten_map 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap flattenAsMap() {
		/*** PROTECTED REGION ID(isl_set_flatten_map) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_set_flatten_map(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_lift 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet lift() {
		/*** PROTECTED REGION ID(isl_set_lift) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_lift(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_align_params 
	 * 
	 * @take this model
	 * @generated
	**/
	public ISLSet alignParams(ISLSpace model) {
		/*** PROTECTED REGION ID(isl_set_align_params) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this, model);
			try {
				res = ISLSet.build(ISLNative.isl_set_align_params(getNativePtr(this), getNativePtr(model)));
			} finally {
				taken(this);
				taken(model);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_add_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet addDims(ISLDimType type, int n) {
		/*** PROTECTED REGION ID(isl_set_add_dims) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_add_dims(getNativePtr(this), type.getValue(), n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_insert_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet insertDims(ISLDimType type, int pos, int n) {
		/*** PROTECTED REGION ID(isl_set_insert_dims) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_insert_dims(getNativePtr(this), type.getValue(), pos, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_move_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet moveDims(ISLDimType dst_type, int dst_pos, ISLDimType src_type, int src_pos, int n) {
		/*** PROTECTED REGION ID(isl_set_move_dims) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_move_dims(getNativePtr(this), dst_type.getValue(), dst_pos, src_type.getValue(), src_pos, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_wrapped_domain_map 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap wrappedDomainMap() {
		/*** PROTECTED REGION ID(isl_set_wrapped_domain_map) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_set_wrapped_domain_map(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_intersect_params 
	 * 
	 * @take this params
	 * @generated
	**/
	public ISLSet intersectParams(ISLSet params) {
		/*** PROTECTED REGION ID(isl_set_intersect_params) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this, params);
			try {
				res = ISLSet.build(ISLNative.isl_set_intersect_params(getNativePtr(this), getNativePtr(params)));
			} finally {
				taken(this);
				taken(params);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_intersect 
	 * 
	 * @take this set2
	 * @generated
	**/
	public ISLSet intersect(ISLSet set2) {
		/*** PROTECTED REGION ID(isl_set_intersect) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this, set2);
			try {
				res = ISLSet.build(ISLNative.isl_set_intersect(getNativePtr(this), getNativePtr(set2)));
			} finally {
				taken(this);
				taken(set2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_union 
	 * 
	 * @take this set2
	 * @generated
	**/
	public ISLSet union(ISLSet set2) {
		/*** PROTECTED REGION ID(isl_set_union) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this, set2);
			try {
				res = ISLSet.build(ISLNative.isl_set_union(getNativePtr(this), getNativePtr(set2)));
			} finally {
				taken(this);
				taken(set2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_subtract 
	 * 
	 * @take this set2
	 * @generated
	**/
	public ISLSet subtract(ISLSet set2) {
		/*** PROTECTED REGION ID(isl_set_subtract) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this, set2);
			try {
				res = ISLSet.build(ISLNative.isl_set_subtract(getNativePtr(this), getNativePtr(set2)));
			} finally {
				taken(this);
				taken(set2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_apply 
	 * 
	 * @take this map
	 * @generated
	**/
	public ISLSet apply(ISLMap map) {
		/*** PROTECTED REGION ID(isl_set_apply) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this, map);
			try {
				res = ISLSet.build(ISLNative.isl_set_apply(getNativePtr(this), getNativePtr(map)));
			} finally {
				taken(this);
				taken(map);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_preimage_multi_aff 
	 * 
	 * @take this ma
	 * @generated
	**/
	public ISLSet preimage(ISLMultiAff ma) {
		/*** PROTECTED REGION ID(isl_set_preimage_multi_aff) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this, ma);
			try {
				res = ISLSet.build(ISLNative.isl_set_preimage_multi_aff(getNativePtr(this), getNativePtr(ma)));
			} finally {
				taken(this);
				taken(ma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_preimage_pw_multi_aff 
	 * 
	 * @take this pma
	 * @generated
	**/
	public ISLSet preimage(ISLPWMultiAff pma) {
		/*** PROTECTED REGION ID(isl_set_preimage_pw_multi_aff) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this, pma);
			try {
				res = ISLSet.build(ISLNative.isl_set_preimage_pw_multi_aff(getNativePtr(this), getNativePtr(pma)));
			} finally {
				taken(this);
				taken(pma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_preimage_multi_pw_aff 
	 * 
	 * @take this mpa
	 * @generated
	**/
	public ISLSet preimage(ISLMultiPWAff mpa) {
		/*** PROTECTED REGION ID(isl_set_preimage_multi_pw_aff) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this, mpa);
			try {
				res = ISLSet.build(ISLNative.isl_set_preimage_multi_pw_aff(getNativePtr(this), getNativePtr(mpa)));
			} finally {
				taken(this);
				taken(mpa);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_product 
	 * 
	 * @take this set2
	 * @generated
	**/
	public ISLSet product(ISLSet set2) {
		/*** PROTECTED REGION ID(isl_set_product) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this, set2);
			try {
				res = ISLSet.build(ISLNative.isl_set_product(getNativePtr(this), getNativePtr(set2)));
			} finally {
				taken(this);
				taken(set2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_flat_product 
	 * 
	 * @take this set2
	 * @generated
	**/
	public ISLSet flatProduct(ISLSet set2) {
		/*** PROTECTED REGION ID(isl_set_flat_product) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this, set2);
			try {
				res = ISLSet.build(ISLNative.isl_set_flat_product(getNativePtr(this), getNativePtr(set2)));
			} finally {
				taken(this);
				taken(set2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_gist 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLSet gist(ISLSet context) {
		/*** PROTECTED REGION ID(isl_set_gist) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLSet.build(ISLNative.isl_set_gist(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_gist_params 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLSet gistParams(ISLSet context) {
		/*** PROTECTED REGION ID(isl_set_gist_params) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLSet.build(ISLNative.isl_set_gist_params(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_partial_lexmin 
	 * 
	 * @take this dom
	 * @generated
	**/
	public ISLSet partialLexMin(ISLSet dom) {
		/*** PROTECTED REGION ID(isl_set_partial_lexmin) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this, dom);
			try {
				res = ISLSet.build(ISLNative.isl_set_partial_lexmin(getNativePtr(this), getNativePtr(dom)));
			} finally {
				taken(this);
				taken(dom);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_partial_lexmax 
	 * 
	 * @take this dom
	 * @generated
	**/
	public ISLSet partialLexMax(ISLSet dom) {
		/*** PROTECTED REGION ID(isl_set_partial_lexmax) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this, dom);
			try {
				res = ISLSet.build(ISLNative.isl_set_partial_lexmax(getNativePtr(this), getNativePtr(dom)));
			} finally {
				taken(this);
				taken(dom);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_lexmin 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet lexMin() {
		/*** PROTECTED REGION ID(isl_set_lexmin) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_lexmin(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_lexmax 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet lexMax() {
		/*** PROTECTED REGION ID(isl_set_lexmax) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_lexmax(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_lexmin_pw_multi_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPWMultiAff lexMinAsPWMultiAff() {
		/*** PROTECTED REGION ID(isl_set_lexmin_pw_multi_aff) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_set_lexmin_pw_multi_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_lexmax_pw_multi_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPWMultiAff lexMaxAsPWMultiAff() {
		/*** PROTECTED REGION ID(isl_set_lexmax_pw_multi_aff) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_set_lexmax_pw_multi_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_get_stride_info 
	 * 
	 * @generated
	**/
	public ISLStrideInfo getStrideInfo(int pos) {
		/*** PROTECTED REGION ID(isl_set_get_stride_info) DISABLED START ***/
		ISLStrideInfo res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLStrideInfo.build(ISLNative.isl_set_get_stride_info(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_get_stride 
	 * 
	 * @generated
	**/
	public ISLVal getStride(int pos) {
		/*** PROTECTED REGION ID(isl_set_get_stride) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLVal.build(ISLNative.isl_set_get_stride(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_get_basic_set_at 
	 * 
	 * @generated
	**/
	public ISLBasicSet getBasicSetAt(int pos) {
		/*** PROTECTED REGION ID(isl_set_get_basic_set_at) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLBasicSet.build(ISLNative.isl_set_get_basic_set_at(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_numberof_points 
	 * 
	 * @generated
	**/
	public int getNbPoints() {
		/*** PROTECTED REGION ID(isl_set_numberof_points) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_set_numberof_points(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_get_point_at 
	 * 
	 * @generated
	**/
	public ISLPoint getPointAt(int pos) {
		/*** PROTECTED REGION ID(isl_set_get_point_at) DISABLED START ***/
		ISLPoint res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLPoint.build(ISLNative.isl_set_get_point_at(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * lex_next 
	 * 
	 * @generated
	**/
	public ISLMap getLexNextMap(int nbInnerLoop) {
		/*** PROTECTED REGION ID(lex_next) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLMap.build(ISLNative.lex_next(getNativePtr(this), nbInnerLoop));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * lex_next_power 
	 * 
	 * @generated
	**/
	public ISLMap getLexNextPowerMap(int nbInnerLoop, int power) {
		/*** PROTECTED REGION ID(lex_next_power) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLMap.build(ISLNative.lex_next_power(getNativePtr(this), nbInnerLoop, power));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * lex_pred 
	 * 
	 * @generated
	**/
	public ISLMap getLexPredMap(int nbInnerLoop) {
		/*** PROTECTED REGION ID(lex_pred) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLMap.build(ISLNative.lex_pred(getNativePtr(this), nbInnerLoop));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * lex_pred_power 
	 * 
	 * @generated
	**/
	public ISLMap getLexPredPowerMap(int nbInnerLoop, int power) {
		/*** PROTECTED REGION ID(lex_pred_power) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLMap.build(ISLNative.lex_pred_power(getNativePtr(this), nbInnerLoop, power));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * clear_tuple_name 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet clearTupleName() {
		/*** PROTECTED REGION ID(clear_tuple_name) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.clear_tuple_name(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLSet_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
